/****************************************************************************
*!
*! FILE NAME  : e100boot.h
*!
*! DESCRIPTION: Common between cbl and sbl
*!
*! ---------------------------------------------------------------------------
*! (C) Copyright 1998-2006, Axis Communications AB, LUND, SWEDEN
*!***************************************************************************/

#ifndef E100BOOT_H
#define E100BOOT_H

#include <compiler.h>

#define DWORD_ALIGN(x) ((x)&0xfffffffc)

#define CRC_LEN 4

#define TRUE  1
#define FALSE 0

#define NL 1
#define NO_NL 0

#define STRING      0
#define INT         1
#define ACK         2
#define BOOT_PACKET 3
#define BOOT_CMDS   4
#define NET_INT     5
#define NET_INT_NL  6
#define FILE_PACKET 7

/* commands to cbl */
#define END_OF_CMDS           0
#define JUMP                  1  
#define MEM_TEST              2
#define PACKET_INFO           3
#define SET_REGISTER          4
#define GET_REGISTER          5
#define MEM_DUMP              6
#define MEM_CLEAR             7
#define MEM_VERIFY            8
#define FLASH                 9
#define PAUSE_LOOP            10
#define LOOP	              11
#define BAUDRATE              12
#define NAND_FLASH            13
#define STUPID_NAND_FLASH     14
#define NAND_FLASH_DUMP       15
#define NAND_FLASH_OOB_DUMP   16
#define NAND_FLASH_ERASE      17
#define NAND_FLASH_MARK_BAD   18
#define NAND_FLASH_IGNORE_BAD 19
#define NAND_FLASH_OOB_DUMP_BAD 20
#define RESTART_FS              21

#define ERR_FLASH_OK        0
#define ERR_FLASH_NONE      1
#define ERR_FLASH_TOO_SMALL 2
#define ERR_FLASH_VERIFY    3
#define ERR_FLASH_ERASE     4

/* This is where the commands are transfered to, including the CRC */
#define IO_BUF_START	0x3801f800
#define IO_BUF_END	0x3801fc00

struct packet_header_T	/* Size = 38 */
{  
  byte      dest[6];
  byte      src[6];
  uword     length;
  udword    snap1;
  udword    snap2;
  udword    tag;		
  udword    seq;
  udword    type;
  udword    id;    
} __attribute__ ((packed));



#endif /* E100BOOT_H */
