#include <stdlib.h>

#ifndef _SYSCALL_H
#define _SYSCALL_H

/* syscall numbers */
#define SYSCALL_YIELD   		0
#define SYSCALL_GETPID  		1
#define SYSCALL_EXIT    		2
#define SYSCALL_ALLOC_RANDOM_DATA 	3
#define SYSCALL_VIRT2PHYS        	4
#define SYSCALL_ALLOC_SHARED        	5
#define SYSCALL_PHYS2VIRT        	6
#define SYSCALL_SET_INTR_VECT        	7
#define SYSCALL_EI        	        8
#define SYSCALL_DI        	        9

#if 0
#undef ASSERT
/* Fail if cond is false */
#define ASSERT( cond ) { \
  if( !(cond) ) { \
    PERROR( "assertion failed: " #cond ); \
    FAIL(); \
  } \
}
#endif

#define PERROR(arg) print_str( "\nERROR: " arg )

#if 0
/* Test PASSED */
#define PASS() do { print_str( "\ntest passed: " ); \
                    print_str( test_module ); \
                    print_str( "." ); \
                    print_str( test_name ); \
                    print_str( ERRPOS ); \
                    print_str( "\n" ); \
                    test_name = "<none>"; \
                  } while( 0 )

/* Test FAILED */
#undef FAIL
#define FAIL() do { print_str( "\ntest failed: " ); \
                    print_str( test_module ); \
                    print_str( "." ); \
                    print_str( test_name ); \
                    print_str( ERRPOS ); \
                    print_str( "\n" ); \
		    exit(EXIT_FAILURE); \
                  } while( 0 )

#endif

#define ERRPOS " @" __FILE__ ":" STRINGIFY(__LINE__)

#define STRINGIFYFY(i) #i
#define STRINGIFY(i) STRINGIFYFY(i)

extern char *test_module;
extern char *test_name;
extern int preempt_cnt;

int  getpid();
void yield();
void exit(int status);
int  preempt_is_off();
void preempt_on();
void preempt_off();
void *syscall_alloc_random_data(unsigned min_size,
			  unsigned max_size,
			  unsigned align,
			  unsigned *seed,
			  unsigned *csize);
unsigned CPU_GET_SIM_TIME();

#undef PREEMPT_OFF_SAVE
#define PREEMPT_OFF_SAVE()

#if 0
 \
{ \
   if (preempt_cnt == 0) { \
     preempt_off(); \
   } \
   preempt_cnt++; \
}

#endif

#undef PREEMPT_RESTORE
#define PREEMPT_RESTORE()

#if 0
 \
{ \
    preempt_cnt = preempt_cnt > 0 ? preempt_cnt-1 : 0; \
   if (preempt_cnt == 0) { \
     preempt_on(); \
   } \
}
#endif

// base address of shared memory   (uncached)
#define shmem_offset (0x20000000 | 0x80000000)

#define kick_the_dog CPU_KICK_DOG

#if 0
typedef unsigned int shmem_handle;
shmem_handle   alloc_shared( unsigned size );
void          *ptr_shared( shmem_handle handle );
void CPU_KICK_DOG();
#endif

void CPU_SET_INT_VEC(unsigned vecnr, unsigned addr);
#define CPU_SET_INT_VECT CPU_SET_INT_VEC

#endif /* _SYSCALL_H */
