/* time.h for cris */
#ifndef _TIME
#define _TIME
#include <stddef.h>
typedef unsigned int clock_t;
typedef unsigned long time_t;

struct tm {
  int tm_sec;
  int tm_min;
  int tm_hour;
  int tm_mday;
  int tm_mon;
  int tm_year;
  int tm_wday;
  int tm_yday;
  int tm_isdst;
};

struct timeval {
  long tv_sec;			/* seconds */
  long tv_usec;			/* microseconds */
};

struct timezone {
  int  tz_minuteswest;		/* minutes west of Greenwich */
  int  tz_dsttime;		/* type of dst correction */
  };

struct  tms  {
  time_t tms_utime;  /* user time */
  time_t tms_stime;  /* system time */
  time_t tms_cutime; /* user time of children */
  time_t tms_cstime; /* system time of children */
};

#define CLOCKS_PER_SEC 1000000

/* declarations */

char *asctime(const struct tm *);
clock_t clock(void);
char *ctime(const time_t *);
double difftime(time_t, time_t);
struct tm *gmtime(const time_t *);
struct tm *localtime(const time_t *);
time_t mktime(struct tm *);
size_t strftime(char *, size_t, const char *,
	const struct tm *);
time_t time(time_t *);
#endif
