#include <stdio.h>
#include <errno.h>
#include <dma_defs.h>
#include <ser_defs.h>
#include <eth_defs.h>
#include <dma.h>
#include <reg_map.h>
#include <vcpu.h>
#include "stdiostuff.h"

extern FILE ttyS0;
extern FILE ttyS1;
extern FILE ttyS2;
extern FILE ttyS3;
extern FILE eth0;

struct packet_header_T tx_header;
extern unsigned int    eth0_dest_0;
extern unsigned short  eth0_dest_1;
extern unsigned        r_network_tr_ctrl;

extern dma_descr_context descr_context_tx;
extern dma_descr_data  tx_descr;
extern dma_descr_data  tx_descr2;

char __eth0_dma_buf[TX_BUF_SIZE];
static unsigned short __eth0_buf_cnt = 0;

int 
fputc(int c, FILE *fd)
{
  reg_ser_rs_stat_din rs_stat_din;
  reg_ser_rw_dout rw_dout = {c};

#define SERWR(n) \
  do { \
    rs_stat_din = REG_RD(ser, regi_ser##n, rs_stat_din);\
  } while (rs_stat_din.tr_rdy == regk_ser_no);\
  REG_WR(ser, regi_ser##n, rw_dout, rw_dout);

  if (fd == &ttyS0) {
    SERWR(0);
    return(c);
  }

  else if (fd == &ttyS1) {
    SERWR(1);
    return(c);
  }

  else if (fd == &ttyS2) {
    SERWR(2);
    return(c);
  }

  else if (fd == &ttyS3) {
    SERWR(3);
    return(c);
  }

  else if (fd == &eth0) {
    __eth0_dma_buf[__eth0_buf_cnt] = (char)c;
    __eth0_buf_cnt++;

    /* enable for debug */
    //    SERWR(0);

    if((__eth0_buf_cnt == 1023) || ((char)c == '\n') || ((char)c == 0)) {
      __eth0_dma_buf[__eth0_buf_cnt] = 0; /* end string */


      send_net_string(__eth0_dma_buf);
      
      __eth0_buf_cnt = 0;
    }
    
    return(c);
  }
  
  
  /* if no fd set, enable for debug */
  //  SERWR(0);
  return(c);
  
}
