#ifndef CYGONCE_HAL_HAL_INTR_H
#define CYGONCE_HAL_HAL_INTR_H

//=============================================================================
//
//	hal_intr.h
//
//	HAL Interrupt and clock support
//
//=============================================================================

// Microsecond delay
// Transform microseconds to number of tics of timer:
// The clock dividor run at 3200 / 217 MHZ
// This is roughly 14.75 MHZ.
//  (microseconds * 10e-6 s) * ((3200 / 217) * 10e6 Hz) =
// = microseconds * (3200/217) tics
//
// By first multiplying and after that divide, we ensure that
// the error is minimized. The + 216 part is to get the roof value of the
// division. 
extern void hal_delay_us(cyg_int32 usecs);
#define HAL_DELAY_US(usecs) hal_delay_us((((usecs)*3200)+216)/217)
//-----------------------------------------------------------------------------
#endif // ifndef CYGONCE_HAL_HAL_INTR_H
// End of hal_intr.h
