/*
 * Taken from arch/cris/arch-v32/drivers/nandflash.c
 * and modified to use for Axis RFL.
 *
 *  Copyright (c) 2004
 *
 *  Derived from drivers/mtd/nand/spia.c
 * 	  Copyright (C) 2000 Steven J. Hill (sjhill@realitydiluted.com)
 * 
 * $Id: nandflash.c,v 1.2 2006/11/08 16:49:54 ronny Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */

#if 0
#include <cyg/hal/hwregs/reg_map.h>
#include <cyg/hal/hwregs/reg_rdwr.h>
#include <cyg/hal/hwregs/gio_defs.h>
#include <cyg/hal/hwregs/bif_core_defs.h>

#include <cyg/hal/nandflash.h>
#else
#include <reg_map.h>
#include <reg_rdwr.h>
#include <gio_defs.h>
#include <bif_core_defs.h>

#include <nandflash.h>
#endif

/* Pin mappings for NAND control/status lines on PA port */
/* Although we could theoretically put the pins anywhere, it makes most
 * sense to put them in the same place as the Boot ROM expects to find them.
 */

#define CE_BIT  4
#define CLE_BIT 5
#define ALE_BIT 6
#define BY_BIT  7

/* 
 *	hardware specific access to control-lines
 */
void hal_nand_hwcontrol(int cmd)
{
	reg_gio_rw_pa_dout dout = REG_RD(gio, regi_gio, rw_pa_dout);

	//	printf(">hal_nand_hwcontrol(%s) %x\n", __FILE__, cmd);

	switch (cmd) {
		case NAND_SET_CLE:
		     dout.data |= (1<<CLE_BIT);
		     break;
		case NAND_CLR_CLE: 
		     dout.data &= ~(1<<CLE_BIT);
		     break;
		case NAND_SET_ALE:
		     dout.data |= (1<<ALE_BIT);
		     break;
		case NAND_CLR_ALE: 
		     dout.data &= ~(1<<ALE_BIT);
		     break;
		case NAND_SET_NCE:
		     dout.data &= ~(1<<CE_BIT);
		     break;
		case NAND_CLR_NCE:
		     dout.data |= (1<<CE_BIT);
		     break;
	}
	REG_WR(gio, regi_gio, rw_pa_dout, dout);
}


/*
 * Read device ready pin
 */
int hal_nand_device_ready(void)
{
	reg_gio_r_pa_din din = REG_RD(gio, regi_gio, r_pa_din);
	return (din.data & (1 << BY_BIT)) != 0;
}


/*
 * Initialization of nand specific hardware
 */
void hal_nand_init(void)
{
	reg_bif_core_rw_grp3_cfg bif_cfg = REG_RD(bif_core, regi_bif_core, rw_grp3_cfg);
	reg_gio_rw_pa_oe pa_oe = REG_RD(gio, regi_gio, rw_pa_oe);
	struct nand_chip *this;

	pa_oe.oe |= 1 << CE_BIT;
	pa_oe.oe |= 1 << ALE_BIT;
	pa_oe.oe |= 1 << CLE_BIT;
	pa_oe.oe &= ~ (1 << BY_BIT);
	REG_WR(gio, regi_gio, rw_pa_oe, pa_oe);

	bif_cfg.gated_csp0 = regk_bif_core_rd;
	bif_cfg.gated_csp1 = regk_bif_core_wr;
	REG_WR(bif_core, regi_bif_core, rw_grp3_cfg, bif_cfg);
}

/************************* END OF FILE ****************************/
