/*
 * Taken from arch/cris/arch-v32/drivers/nandflash.c
 * and modified to use for Axis RFL.
 *
 *  Copyright (c) 2004
 *
 *  Derived from drivers/mtd/nand/spia.c
 * 	  Copyright (C) 2000 Steven J. Hill (sjhill@realitydiluted.com)
 * 
 * $Id: nandflash.h,v 1.2 2006/11/08 16:50:28 ronny Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */

#include <reg_map.h>
#include <reg_rdwr.h>
#include <gio_defs.h>
#include <bif_core_defs.h>

/* Commands for hal_nand_hwcontrol */
#define NAND_SET_NCE    (1)
#define NAND_CLR_NCE    (2)
#define NAND_SET_CLE    (3)
#define NAND_CLR_CLE    (4)
#define NAND_SET_ALE    (5)
#define NAND_CLR_ALE    (6)

/* addresses for NAND chip access */
#define NAND_RD_ADDR 0x90000000
#define NAND_WR_ADDR 0x94000000


/* hardware specific access to control lines */
void hal_nand_hwcontrol(int cmd);

/* read device ready pin */
int hal_nand_device_ready(void);

/* Initialization of nand specific hardware */
void hal_nand_init(void);

/************************* END OF FILE ****************************/
