/*!***************************************************************************
*!
*! FILE NAME  : net_lv1.c
*!
*! DESCRIPTION: Only used by level 1.
*!
*! ---------------------------------------------------------------------------
*! (C) Copyright 1998-2006, Axis Communications AB, LUND, SWEDEN
*!***************************************************************************/

#include <e100boot.h>
#include <cbl.h>

extern struct packet_header_T tx_header;

void 
next_level_boot(void)
{

  net_init(1);

  send_net_ack();
  
  init_dma1();

  while (nbr_read < (udword)bytes_to_read) {
    if (rx_descr2.in_eop == regk_dma_yes) { 
      handle_network_read();
    }
    
    if (timeout()) {
      send_net_ack();
    }
    
  }

  /* write varibles in int mem for level2 loader */
  *(unsigned*)ADDR_SEQ   = seq;
  *(unsigned*)ADDR_ID    = tx_header.id;


#if 1
  /* jump to level 2 loader */
  __asm__ volatile ("\
jump 0x38000800\n\t\
nop\n\t\
");
#endif
  
}

