/****************************************************************************
*!
*! FILE NAME  : netio.c
*!
*! DESCRIPTION: network functions for level 2
*!
*! ---------------------------------------------------------------------------
*! (C) Copyright 1998-2006, Axis Communications AB, LUND, SWEDEN
*****************************************************************************/

#include <e100boot.h>
#include <cbl.h>

static dma_descr_data volatile tx_descr2
__attribute__ ((aligned (32))) = 
{
  .next = NULL,
  .buf  = (char*)&tx_header,
  .eol  = regk_dma_yes,
  .out_eop = regk_dma_yes,
  .intr    = regk_dma_no,
  .wait    = regk_dma_yes,
  .in_eop  = regk_dma_no,
  .md      = 0,
  .after   = (char*)&tx_header+sizeof(struct packet_header_T),
};

void 
send_net_string(char *str)
{
  unsigned i;

  tx_descr.next   = (dma_descr_data*)&tx_descr2;
  for (i=0; str[i]; i++);	/* strlen */
  
  tx_header.length = sizeof(struct packet_header_T) - ETHERNET_HDR_SIZE + i;
  tx_header.length = tx_header.length > 64 ? tx_header.length : 64;
  tx_header.length = HTONS(tx_header.length);
  tx_header.seq    = HTONL(seq);
  tx_header.type   = STRING;

  tx_descr.wait    = regk_dma_no;
  tx_descr.out_eop = regk_dma_no;
  tx_descr.eol     = regk_dma_no;

  tx_descr2.buf    = (char*)str;
  tx_descr2.after  = tx_descr2.buf + i + 1;
  
  start_tx();
  { /* Pause so we don't saturate network. */
    udword i;

    /* Hehe, the asm will fool gcc to not remove the loop even though it
       probably should. If we volatile i the code will be a few bytes
       longer than this version. Well I really did it like this just
       because it is possible... */
    for(i=0; i!=(65536); i++)
      __asm__ ("");		
  }
  
}

/**************************************************************************/

void 
send_net_hex(udword v, byte nl)
{

  tx_descr.next   = (dma_descr_data*)&tx_descr2;
  tx_descr.out_eop = regk_dma_no;
  tx_header.length = HTONS(64-ETHERNET_HDR_SIZE);
  tx_header.seq    = HTONL(seq);
  tx_header.type  = nl ? HTONL(NET_INT_NL) : HTONL(NET_INT);

  
  v = HTONL(v);
  tx_descr.wait    = regk_dma_no;
  tx_descr.out_eop = regk_dma_no;
  tx_descr.eol     = regk_dma_no;

  tx_descr2.buf    = (char*)&v;
  tx_descr2.after  = tx_descr2.buf + (uword)sizeof(udword);
  
  start_tx();
  {
    udword i;
    
    for(i=0; i!=65536; i++)
      __asm__ ("");		
  }

}

/**************************************************************************/
