#include <cbl.h>	
#include <timer_defs.h>
#include <ser_defs.h>
#include <config_defs.h>

/* Time-stamp: <2006-10-18 13:41:11 ronny> */

extern int timeout(void);

void 
ser_init(void)
{

  { /* enable clock region and set baudrate. */

    /* read pll status */
    reg_config_rw_clk_ctrl rw_clk_ctrl = REG_RD(config, regi_config, rw_clk_ctrl);
    
    { /* Start fixed i/o block clock region.  */
      rw_clk_ctrl.fix_io = regk_config_yes;
      REG_WR(config, regi_config, rw_clk_ctrl, rw_clk_ctrl);
    }

    reg_ser_rw_rec_baud_div rw_rec_baud_div = {0,};
    reg_ser_rw_tr_baud_div rw_tr_baud_div   = {0,};
     
    if (rw_clk_ctrl.pll == regk_config_yes) {
      /* set baudrate ~115200 (114679) for pll on*/
      rw_rec_baud_div.div = 109; 
      rw_tr_baud_div.div  = 109; 
    }
    else {
      /* set baudrate ~9600 (9615) for pll off */
      rw_rec_baud_div.div = 39;
      rw_tr_baud_div.div  = 39; 
    }
    REG_WR(ser, regi_ser0, rw_rec_baud_div, rw_rec_baud_div);
    REG_WR(ser, regi_ser0, rw_tr_baud_div,  rw_tr_baud_div);
  }
  
  { /* set base_freq and enable */
    reg_ser_rw_rec_ctrl rw_rec_ctrl = REG_RD(ser, regi_ser0, rw_rec_ctrl);
    
    rw_rec_ctrl.base_freq = regk_ser_f100;
    rw_rec_ctrl.en = regk_ser_yes;
    
    REG_WR(ser, regi_ser0, rw_rec_ctrl, rw_rec_ctrl);
  }

  { /* set base_freq and enable */
    reg_ser_rw_tr_ctrl rw_tr_ctrl = REG_RD(ser, regi_ser0, rw_tr_ctrl);
    
    rw_tr_ctrl.base_freq = regk_ser_f100;
    rw_tr_ctrl.en = regk_ser_yes;
    
    REG_WR(ser, regi_ser0, rw_tr_ctrl, rw_tr_ctrl);
  }

#if 0
  while(1) {
    send_ser_ack();
  }
#endif
}

void
send_ser_ack(void)
{

  { /* waitfor ready */
    reg_ser_r_stat_din r_stat_din;
    do {
      r_stat_din = REG_RD(ser, regi_ser0, r_stat_din);
      
    } while (r_stat_din.tr_rdy == regk_ser_no);
  }
  
  { /* send char */
    reg_ser_rw_dout rw_dout;
    
    rw_dout.data = '+';
    
    REG_WR(ser, regi_ser0, rw_dout, rw_dout);
  }

}

