/* $Id: vcpu.h,v 1.3 2004/01/26 20:45:37 stefans Exp $
 *
 *
 * System testbench implementations of the VCPU primitives
 */

#ifndef VCPU_H
#define VCPU_H

#include "reg_rdwr.h"

#define CPU_SMIF_RD( addr, smif_d, size)

#define CPU_SMIF_WR( addr, smif_d, size)

#define CPU_SMIF_ABORT_RD( addr, smif_d, size)

#define CPU_SMIF_ABORT_WR( addr, smif_d, size)

#define CPU_SET_VMEM_BASE( addr, vmem_nbr)


void CPU_SLEEP( unsigned t );

void CPU_STOP_SIM(void);

//void CPU_INIT_INT(void);

void CPU_SET_INT_VEC( unsigned vecnr, unsigned addr );

void CPU_ENABLE_INT_VEC( unsigned vecnr );

void CPU_DISABLE_INT_VEC( unsigned vecnr );

/* returns TRUE or FALSE */
int CPU_IS_ENABLED_INT_VEC( unsigned vecnr );

/* returns TRUE or FALSE */
int CPU_IS_ACTIVE_INT_VEC( unsigned vecnr );

/* returns the current simulator time in nS */
unsigned CPU_GET_SIM_TIME(void);

void CPU_KICK_DOG(void);

void CPU_WATCHDOG_TIMEOUT( unsigned t );

#endif // ifndef VCPU_H
