#!/usr/bin/perl

if (0) {
print "struct reg_des {
  char *name;
  unsigned int addr;
} reg_des[] = {\n";
while(<>) {
  if (m|^/\* Register) {
    print "  \"$1\", $2,\n";
  }
}
  print "  NULL, 0
};
";

}

sub reg_addr_list()
{
  my %addr;
  my $reg_map = '/n/asic/projects/guinness/design/top/sw/include/reg_map.h';

  parse_reg_map($reg_map);

  for my $scope (keys %rdesc) {
    my $rfile = $rdesc{$scope}{rfile};
    if ($rfile) {
      read_reg_file($scope, $rfile);
    }
    else {
      die "error\n";
    }
  }

  nprint "\\section{Register adresses}\n\n";
  nprint "\\label{sec:Register adresses}\n\n";

  for my $scope (sort keys %rdesc) {
    my @inst;

    if (exists $rdesc{$scope}{inst}) {
      @inst = @{$rdesc{$scope}{inst}};
    }
    else {
      @inst = ($scope);
    }

    for my $inst (@inst) {
      d3 "inst $inst\n";
      my $base = hex($regi{$inst});
      if (!$base > 0) {
	dwarn "reg_addr_list: No base address for instance $inst.\n";
      }

      for my $regname ( RDesc::regs $scope, 'name' ) {
	my $reg = RDesc::reg( $scope, $regname );
	my $offset = $reg->{addr};
	my $addr = $base+($offset*4);
	my $hb = sprintf("0x%8.8x", $base);
	my $ha = sprintf("0x%8.8x", $addr);
	d3("# $scope, $inst\@$hb, $regname\($offset) = $ha\n");
	if (exists($addr{$addr})) {
#	  print "The following registers lie at same address!\n";
#	  print("# $scope, $inst\@$hb, $regname\($offset) = $ha\n");
#	  print("# $addr{$addr}{scope}, $addr{$addr}{inst}, $addr{$addr}{reg}\n");
	}
	my %tmp;
	$tmp{reg}   = $regname;
	$tmp{scope} = $scope;
	$tmp{inst}  = $inst;
	push @{$addr{$addr}}, {%tmp};
      }
    }
  }

  # percent of total_width, sum should be 100%
  my $col_width_addr  = $total_width*0.20;
  my $col_width_scope = $total_width*0.20;
  my $col_width_inst  = $total_width*0.30;
  my $col_width_reg   = $total_width*0.30;

  nprint "

\\begin{longtable}[l]{%
 >{\\columncolor[gray]{0.8}}p{$col_width_addr\mm}| 
 >{\\columncolor[gray]{0.8}}p{$col_width_scope\mm}| 
 >{\\columncolor[gray]{0.8}}p{$col_width_inst\mm}| 
 >{\\columncolor[gray]{0.8}}p{$col_width_reg\mm}}

\\textbf{Address} & \\textbf{Scope} & \\textbf{Instance} & \\textbf{Register} \\\\ \\hline

";

  for my $addr (sort numerically keys %addr) {
    for (my $i=0; %{$addr{$addr}[$i]}; $i++) {
      my $str = sprintf("0x%8.8x", $addr);
      nprint $str;
      nprint " & ";
      lprint $addr{$addr}[$i]{scope};
      nprint " & ";
      lprint $addr{$addr}[$i]{inst};
      nprint " & ";
      lprint $addr{$addr}[$i]{reg};
      nprint "\\\\ \\hline\n";
    }
  }
  
  nprint '
\end{longtable}

';

#  close LD;
#  $file_name = $tmp_file_name;
}

# parse a register description


