/*****************************************************************************
*!
*! FILE NAME  : application.h
*!
*! ---------------------------------------------------------------------------
*! Copyright (C) 2004, Axis Communications AB, LUND, SWEDEN
*!***************************************************************************/

#ifndef APPLICATION_H
#define APPLICATION_H

/****************** INCLUDE FILES SECTION ***********************************/

#include "profile.h"

/****************** CONSTANT AND MACRO SECTION ******************************/

/****************** TYPE DEFINITION SECTION *********************************/

struct application
{
  struct application* next;
  int pid;     /* PID for this application */
  int samples; /* Number of samples in this application */
  int printed; /* 1 if this application has been listed in output */
  char name[MAX_STRING_LEN];
  struct map* maps; /* All mmap:ed areas */
};

/****************** EXPORTED FUNCTION DECLARATION SECTION *******************/

struct application* add_application(unsigned int pid, struct application* kernel);

#endif
/****************** END OF FILE application.h *******************************/
