/*****************************************************************************
*!
*! FILE NAME  : function.h
*!
*! ---------------------------------------------------------------------------
*! Copyright (C) 2004, Axis Communications AB, LUND, SWEDEN
*!***************************************************************************/

#ifndef FUNCTION_H
#define FUNCTION_H

/****************** INCLUDE FILES SECTION ***********************************/

#include "profile.h"
#include "map.h"

/****************** TYPE DEFINITION SECTION *********************************/

struct function
{
  struct function* next;

  struct map* map;

  char* name;

  unsigned long start;   /* Start address for the function */
  unsigned long end;     /* Last address in the function */

  unsigned long samples; /* Number of samples in this function */

  int printed;           /* 1 if this function has been listed in output yet */
};

/****************** EXPORTED FUNCTION DECLARATION SECTION *******************/

struct function* copy_functions(struct map* map);

#endif
/****************** END OF FILE function.h **********************************/
