/*****************************************************************************
*!
*! FILE NAME  : map.h
*!
*! ---------------------------------------------------------------------------
*! Copyright (C) 2004, Axis Communications AB, LUND, SWEDEN
*!***************************************************************************/

#ifndef MAP_H
#define MAP_H

/****************** INCLUDE FILES SECTION ***********************************/

#include "profile.h"
#include "application.h"

/****************** TYPE DEFINITION SECTION *********************************/

struct map /* Mapped application or lib */
{
  struct map* next;
  struct function* functions;
  char name[MAX_STRING_LEN];
  unsigned int start;  /* Start address of this mmap_ed binary */
  unsigned int end;    /* Last address */
  unsigned int offset; /* Offset to add to start of library */ 
};

/****************** EXPORTED FUNCTION DECLARATION SECTION *******************/

struct map* get_map_entry(struct application* app);
struct map* copy_map(struct map* map);

#endif
/****************** END OF FILE map.h ***************************************/
