# Hey Emacs, this Makefile is in -*- makefile -*- mode!

###########################################################################
# Automatically generate dependencies.

DEPEND_DIR := .depend

ifneq ($(patsubst 2.%,2.x,$(AXIS_GCC_VERSION)),2.x)
# If the compiler is based on gcc 3.x or later then -MP is used to prevent
# problems when header files are removed, and -MF is used to put the
# dependency files in a .depend directory instead of in the main directory.

# Create the .depend directory.
MK_DEPEND_DIR := $(shell $(INSTALL) -d $(DEPEND_DIR))

# The patsubst and subst prevent a leading period and any slashes from
# messing up the name of the dependency file
DEPEND_FLAGS += -MD -MP -MF $(DEPEND_DIR)/$(patsubst .%,_.%,$(subst /,_,$(@:.o=.d))) -MT $@

-include $(DEPEND_DIR)/*.d
else
# Use -MMD instead of -MD as the absolute dependencies generated by -MD
# causes problems if a new compiler is used or the sources are moved. This
# problem is avoided above with -MP, which cannot be used here.
DEPEND_FLAGS += -MMD

-include *.d
endif

CFLAGS   += $(DEPEND_FLAGS)

clean:	remove_depend_files

remove_depend_files:
	$(RM) -r $(DEPEND_DIR) *.d

###########################################################################
