# Hey Emacs, this Makefile is in -*- makefile -*- mode!

###########################################################################

.PHONY:	check
check:
	@if test -z "$(AXIS_CHECK_DIRS)" ; then \
	  # Run imported unit test \
	  $(MAKE) host || true; \
	  $(MAKE) check-log; \
	else \
	  # Run test in axis check framewwork \
	  $(MAKE) check-checkdirs; \
	fi

.PHONY:	check-checkdirs
check-checkdirs:
	@subdirs="$(AXIS_CHECK_DIRS)"; \
	for subdir in $$subdirs; do \
	  if [ -d "$$subdir" ]; then \
	    if ! AXIS_CHECK_SUBDIR="/$$subdir" AXIS_CHECK_TARGET="-C $$subdir check" $(MAKE) check-log; then \
	      fail_dir="1"; \
	    fi; \
	  fi; \
	done; \
	test -z "$$fail_dir" || test -n "$(CHECK_TEST_LOG)"

.PHONY:	check-log
check-log:
	@test_log=$${CHECK_TEST_LOG:-"/dev/null"}; \
	check_dir="$$PWD"; \
	check_dir=$${check_dir#$(AXIS_TOP_DIR)/}; \
	if ! $(MAKE) $(AXIS_CHECK_TARGET) ; then \
	  echo "CHECK-FAIL $$check_dir$(AXIS_CHECK_SUBDIR)" >> $$test_log; \
	  fail_dir="1"; \
	else \
	  echo "CHECK-PASS $$check_dir$(AXIS_CHECK_SUBDIR)" >> $$test_log; \
	fi; \
	test -z "$$fail_dir" || test -n "$(CHECK_TEST_LOG)"

###########################################################################
