# Hey Emacs, this Makefile is in -*- makefile -*- mode!

###########################################################################
# A rule to create the axis_config.h file in the top level directory.

AC_H      = $(AXIS_TOP_DIR)/axis_config.h

$(AC_H):	$(AXIS_TOP_DIR)/.config
	$(MAKE) -C $(AXIS_TOP_DIR) oldconfig

###########################################################################
# This generic rule is used to preprocess files with filepp, and makes it
# possible to, e.g., apply AXIS_CONFIG variables to them.

ACU_H     = $(AXIS_TOP_DIR)/axis_config_unquoted.h

FPPFLAGS   = -DAXIS_DEVELOPER=$(AXIS_DEVELOPER)
FPPMODULES = -m for.pm -m foreach.pm -m bigfunc.pm

%::	%.fpp $(ACU_H)
	$(AT_PRETTY) filepp -b $(FPPFLAGS) $(FPPMODULES) -imacros $(ACU_H)  $< > $@ || (rm -f $@; exit 1)

$(ACU_H):	$(AC_H)
	@echo "Creating $@"
	@sed -e 's/^\([^"]*\) "\(.*\)"$$/\1 \2/' $< > $@

# Do not supply these rules if this file has been included via Rules.axis
# for backwards compatibility.
ifneq ($(AXIS_COMPAT_RULES),y)
clean:	clean_fpp

clean_fpp:
	$(RM) $(patsubst %.fpp,%,$(wildcard *.fpp .*.fpp))
endif

###########################################################################
