#!/usr/bin/perl -w
# Tool to do broadcast ping and list info about hosts that responds.
# $Id: axls.pl,v 1.4 2001/08/07 15:55:04 jonasd Exp $

# get info for interface
if (!defined $ARGV[0])
{
  print "usage: $0 interface\n";
  print "Example: $0 eth0\n";
  exit ;
}

$line = `/sbin/ifconfig $ARGV[0] | grep "inet addr"`;
$line =~ /.*inet addr:(\S*).*$/;
$IPADDR = $1;
$line =~ /.*Bcast:(\S*).*$/;
$BROADCAST = $1;

#$BROADCAST = "255.255.255.255";

print "Pinging $BROADCAST\n\n";

$p="ping -n -c 2 -b";
@replies= `$p $BROADCAST 2>/tmp/err.$$ | grep "icmp_seq=0" | sort`;
$err = `cat /tmp/err.$$`;
if ( grep(/invalid option/, $err ) ){
# Not all ping has -b option
#  print "Trying other ping\n";
  $p="ping -n -c 2";
  @replies= `$p $BROADCAST | grep "icmp_seq=0" | sort`;
}
`rm -f /tmp/err.$$`;
# print @replies;
$j=0;
for ($i = 0; $i<=$#replies; $i++){
  $replies[$i] =~ /.*from\s(\S*)\:.*$/;
  if ($1 eq $IPADDR) # all but ourselves
  {
    $j=1;
  }
  else
  {
    $hosts[$i-$j]= $1;
  }
}

print "These hosts replied\n";

# Now all ip's that replied are in $ip[]
for ($i = 0; $i<=$#hosts; $i++){
  `ping -n -c 1 $hosts[$i]`; # make sure the arpcache is up to date
  $arp="/sbin/arp -n -a $hosts[$i]";
  # print "$arp\n";
  $reply=`$arp`;
  # print "$reply\n";
  $reply =~ /.*\sat\s(\S*).*$/;
  $macs[$i]= $1;
}

#print "Macs @macs\n\n";

for ($i = 0; $i<=$#hosts; $i++){
  if ($macs[$i] =~ /^00:40:8C.*/)
  {    
    $ftp=&ftp_info($hosts[$i]);
    print "$hosts[$i]   $macs[$i]\n  $ftp\n\n";
  }
  else
  {
    print "$hosts[$i]   $macs[$i]\n  (Non-AXIS unit)\n\n";
  }  
}


exit;

sub ftp_info(){
  ($host)=@_;
  my($name,$aliases,$proto)=getprotobyname("tcp");
  socket(SOCK,2,1,$proto);
  # print "H:$host:\n";
  my($a1,$a2,$a3,$a4)=split(/\./,$host);
  $addr_host=pack('C4',$a1,$a2,$a3,$a4);
  my $host=pack('S n a4 x8',2,21,$addr_host);
  if (connect(SOCK,$host))
  {
    print SOCK "\r\n";
    my $reply =<SOCK>;
#    print SOCK "USER root";
#    my $s =<SOCK>;
#    print SOCK "PASS pass";
#    my $s =<SOCK>;
    # print $s;
    close SOCK;
#    $reply =~ /220\s(.*)\sready\.$/;
    $reply =~ /220\s(.*)$/;
    return $1;
  }
  return;
}
  

